#include "IrrCompileConfig.h"



#ifdef _IRR_COMPILE_WITH_X11_DEVICE_
#ifdef _IRR_COMPILE_WITH_BURNINGSVIDEO_


#include "IRenderWindow.h"
#include "CRenderWindowWin32.h"
#include "CBurningVideoContextLinux.h"
#include "CImage.h"
#include "IDepthBuffer.h"



namespace irr
{
namespace video
{


CBurningVideoContextLinux::CBurningVideoContextLinux(
//                        HWND windowHandle,
                        XImage *image,
                        IDepthBuffer* depthBuffer,
                        CImage* backBuffer,
                        IStencilBuffer* stencilBuffer,
                        const SVideoContextConfig& config
                        ) :
    IBurningVideoContext(depthBuffer,backBuffer,stencilBuffer,config)
    , ISoftwareContextLinux(
//                            GetDC(windowHandle)
                            image
                             )
//    , WindowHandle(windowHandle)
{
    //!
//    setTarget(windowHandle)
}



CBurningVideoContextLinux::~CBurningVideoContextLinux()
{

}


bool CBurningVideoContextLinux::isCompatibleWithRenderWindow(IRenderWindow* ) const
{
    return true;
}





bool CBurningVideoContextLinux::setTarget(void* data )
{
    //
    return ISoftwareContextLinux::setTarget( * ((SRenderWindowLinuxHandle*) data) );
//    return false;
}


bool CBurningVideoContextLinux::swapBuffers(core::rect<s32>* src)
{
    return ISoftwareContextLinux::swapBuffers( BackBuffer, src );
//    return false;
}


void CBurningVideoContextLinux::releaseContext()
{

//    delete BackBuffer;
}



} // video
} // irr

#endif // _IRR_COMPILE_WITH_BURNINGSVIDEO_
#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_
