
// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_OPENGL_CONTEXT_WIN32_H_INCLUDED__
#define __C_OPENGL_CONTEXT_WIN32_H_INCLUDED__


#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_WINDOWS_DEVICE_
#ifdef _IRR_COMPILE_WITH_OPENGL_

//#include "IVideoContext.h"
#include "IOpenGLContext.h"

#include <windows.h>
#include <winuser.h>

namespace irr
{
namespace video
{


class COpenGLContextWin32 : public IOpenGLContext
{
public:

    COpenGLContextWin32(COpenGLDriver* driver
//                        , const PIXELFORMATDESCRIPTOR& pfd
                        , const int& pf

                        , const SVideoContextConfig& config, bool external, HDC, HGLRC);
    virtual ~COpenGLContextWin32();

    // passer un void*
//    bool setCurrent(HDC hdc);
    virtual bool setTarget(void * data);


//    bool endCurrent();
//    bool isValid(); //?

    virtual bool swapBuffers();

    virtual void releaseContext();

    virtual bool isCompatibleWithRenderWindow(IRenderWindow*) const;


    virtual bool setDeviceContext(HDC deviceContext);

protected:
    HGLRC   RenderingContext;

private:
    HDC DeviceContext;
//    const PIXELFORMATDESCRIPTOR PixelFormatDescriptor;
    const int PixelFormat;
};

}
}

#endif // _IRR_COMPILE_WITH_OPENGL_
#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_

#endif
