

#ifndef __IRR_C_RENDER_WINDOW_NULL_H__
#define __IRR_C_RENDER_WINDOW_NULL_H__



#include "IRenderWindow.h"
#include "IrrCompileConfig.h"



namespace irr
{

namespace video
{

//class IImage;

// TODO we should be able to create a CRenderWindowNull  from a valid WindowId
class CRenderWindowNull : public IRenderWindow
{

public:
    /** Default constructor.
    //SRenderWindowConfig& config,
    If we are creating a window from nothing
    */
//    CRenderWindowNull();

    /**
     In case window already exists
    **/
    CRenderWindowNull(bool fullscreeen, bool externalWindow, const SRenderWindowConfig& config);

    virtual ~CRenderWindowNull();



    //! sets the caption of the window
    virtual void setWindowCaption(const wchar_t* text)  ;

    //! returns if window is active. if not, nothing need to be drawn
    virtual bool isWindowActive() const  ;

    //! returns if window has focus
    virtual bool isWindowFocused() const  ;

    //! returns if window is minimized
    virtual bool isWindowMinimized() const  ;

    //! AdjustWindowRect
    core::dimension2d<u32> getClientSize() const;

    //! relative to upper-left point of screen (0/0)
    core::dimension2d<u32> getPosition() const;


    virtual bool isFullscreen() const  ;

    //! Get the current color format of the window
    /** \return Color format of the window. */
    virtual video::ECOLOR_FORMAT getColorFormat() const ;

    //! Notifies the device, that it has been resized
    /** used internally only ? **/
    virtual bool resize(const core::dimension2du& newSize);

    //! Sets if the window should be resizable in windowed mode.
    virtual bool setResizable(bool resize=false)  ;

    virtual bool isResizable()  const;


    // bool reset
    virtual bool setFullscreen(const bool& enable);


    //! Minimizes the window.
    virtual void minimizeWindow()  ;

    //! Maximizes the window.
    virtual void maximizeWindow()  ;

    //! Restores the window size.
    virtual void restoreWindow()  ;

    virtual void closeWindow(bool forceDestroy = false) ;

    virtual void forceDestroy() ;


// TODO returns void* ?
//    HWND getWindowHandle() const { return WindowHandle;};
    void* getWindowHandle()  { return WindowHandle;};



protected:

    core::stringc Caption

    bool IsFullscreen;
//    bool ChangedToFullScreen;
    bool IsNonNTWindows;        //! Why that
//    bool Resized;

};



}  // video
} // irr

#endif

#endif
