
// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_SOFTWARE_CONTEXT_LINUX_H_INCLUDED__
#define __C_SOFTWARE_CONTEXT_LINUX_H_INCLUDED__


#include "IrrCompileConfig.h"

#ifdef _IRR_COMPILE_WITH_X11_DEVICE_
#ifdef _IRR_COMPILE_WITH_SOFTWARE_

#include "ISoftwareContext.h"
#include "ISoftwareContextLinux.h"
#include <X11/Xlib.h>


namespace irr
{
namespace video
{

class IRenderWindow;
class CRenderWindowLinux;


class CSoftwareContextLinux : public ISoftwareContext
                                , public ISoftwareContextLinux
{
public:

    CSoftwareContextLinux( IZBuffer* zBuffer, CImage* backBuffer,  const SVideoContextConfig& config,  XImage* softwareImage );
    virtual ~CSoftwareContextLinux();


//    virtual bool setCurrent();
//
//    virtual bool endCurrent();

//    virtual bool present(IImage *image,core::rect<s32>* src);

//    bool swapBuffers();

//    virtual bool isCompatibleWithRenderWindow(IRenderWindow* ) const ;

    virtual bool setTarget(void* ) ;

    virtual bool swapBuffers(core::rect<s32>* src) ;

    virtual void releaseContext();


//    CRenderWindowLinux* Window;
//    XImage* SoftwareImage;
//    video::CImage* BackBuffer;
};

}
}

#endif // _IRR_COMPILE_WITH_SOFTWARE
#endif // _IRR_COMPILE_WITH_X11_DEVICE_

#endif // include quards
